
%global provider_dir %{_libdir}/cmpi

Name:           sblim-cmpi-dhcp
Version:        1.0
Release:        7%{?dist}
Summary:        SBLIM WBEM-SMT DHCP

Group:          Applications/System
License:        EPL
URL:            http://sblim.wiki.sourceforge.net/
Source0:        http://downloads.sourceforge.net/sblim/%{name}-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Patch0:         sblim-cmpi-dhcp-1.0-unused-variables.patch
Patch1:         sblim-cmpi-dhcp-1.0-config-registration.patch
Patch2:         sblim-cmpi-dhcp-1.0-Linux_DHCPServiceConfiguration-registration.patch

BuildRequires:  sblim-cmpi-devel
BuildRequires:  sblim-tools-libra-devel
BuildRequires:  bison flex
Requires:       dhcp sblim-tools-libra cim-server
Provides:       cmpi-dhcp = %{version}-%{release}

%description
The cmpi-dhcp package provides access to the DHCP configuration data
via CIMOM technology/infrastructure.
It contains the DHCP CIM Model, CMPI Provider with the DHCP task specific
Resource Access.

%package        devel
Summary:        SBLIM WBEM-SMT DHCP - Header Development Files
Group:          Development/Libraries
Requires:       sblim-cmpi-dhcp = %{version}-%{release}

%description devel
SBLIM WBEM-SMT DHCP Development Package contains header files and
link libraries for dependent provider packages

%package        test
Summary:        SBLIM WBEM-SMT DHCP - Testcase Files
Group:          Applications/System
Requires:       sblim-cmpi-dhcp = %{version}-%{release}
Requires:       sblim-testsuite

%description test
SBLIM WBEM-SMT DHCP Provider Testcase Files for the SBLIM Testsuite

%prep
%setup -q
%patch0 -p1 -b .unused-variables
%patch1 -p1 -b .config-registration
%patch2 -p1 -b .Linux_DHCPServiceConfiguration-registration


%build
%ifarch s390 s390x ppc ppc64
export CFLAGS="$RPM_OPT_FLAGS -fsigned-char"
%else
export CFLAGS="$RPM_OPT_FLAGS"
%endif
%configure \
        TESTSUITEDIR=%{_datadir}/sblim-testsuite \
#        CIMSERVER=sfcb \
        PROVIDERDIR=%{_libdir}/cmpi/
make


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
# remove unused libtool files
rm -f $RPM_BUILD_ROOT/%{_libdir}/*a
rm -f $RPM_BUILD_ROOT/%{_libdir}/cmpi/*a
mv $RPM_BUILD_ROOT/%{_libdir}/libuniquekey.so $RPM_BUILD_ROOT/%{provider_dir}
%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT


%files -f %{name}.lang
%defattr(-,root,root,-)
%doc %{_datadir}/doc/sblim-cmpi-dhcp-%{version}
%exclude %{_datadir}/doc/sblim-cmpi-dhcp-%{version}/*.test
%doc %{_mandir}/man5/smt_dhcp_ra_support.conf.5.gz
%config(noreplace) %{_sysconfdir}/smt_dhcp*.conf
%{_datadir}/sblim-cmpi-dhcp
%{_libdir}/cmpi/libuniquekey.so
%{_libdir}/libRaToolsDhcp.so.*
%{_libdir}/cmpi/libcmpiLinux_DHCP*.so

%files devel
%defattr(-,root,root,-)
%{_libdir}/libRaToolsDhcp.so

%files test
%defattr(-,root,root,-)
%{_datadir}/sblim-testsuite/test-cmpi-dhcp.sh
%doc %{_datadir}/doc/sblim-cmpi-dhcp-%{version}/*.test
%{_datadir}/sblim-testsuite/dhcpd.conf
%{_datadir}/sblim-testsuite/cim/Linux_DHCP*
%{_datadir}/sblim-testsuite/system/linux/Linux_DHCP*


# Conditional definition of schema and registration files
%define SCHEMA %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPService.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGlobal.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGlobalForService.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGroup.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGroupsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPHost.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPHostsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPOptions.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPOptionsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPParams.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPParamsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPPool.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPPoolsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPRegisteredProfile.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPServiceConfiguration.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPServiceConfigurationForService.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSharednet.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSharednetsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSubnet.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSubnetsForEntity.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPElementConformsToProfile.mof

%define REGISTRATION %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGlobal.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGlobalForService.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGroup.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPGroupsForEntity.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPHost.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPHostsForEntity.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPOptions.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPOptionsForEntity.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPParams.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPParamsForEntity.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPPool.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPPoolsForEntity.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPRegisteredProfile.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPService.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPServiceConfiguration.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPServiceConfigurationForService.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSharednet.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSharednetsForEntity.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSubnet.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPSubnetsForEntity.registration

%define INTEROP_SCHEMA %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPService.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPRegisteredProfile.mof %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPElementConformsToProfile.mof
%define INTEROP_REGISTRATION %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPRegisteredProfile.registration %{_datadir}/sblim-cmpi-dhcp/Linux_DHCPElementConformsToProfile.registration


%pre
function unregister()
{        
  %{_datadir}/%{name}/provider-register.sh -d \
        $1 \
        -m %{SCHEMA} \
        -r %{REGISTRATION} > /dev/null 2>&1 || :;
  %{_datadir}/%{name}/provider-register.sh -d \
        $1 \
        -m %{INTEROP_SCHEMA} \
        -r %{INTEROP_REGISTRATION} > /dev/null 2>&1 || :;
  # don't let registration failure when server not running fail upgrade!
}        
         
# If upgrading, deregister old version
if [ $1 -gt 1 ]
then     
        unregistered=no
        if [ -e /usr/sbin/cimserver ]; then
           unregister "-t pegasus";
           unregistered=yes
        fi  
         
        if [ -e /usr/sbin/sfcbd ]; then
           unregister "-t sfcb";
           unregistered=yes
        fi  
         
        if [ "$unregistered" != yes ]; then
           unregister
        fi  
fi
#  %{_datadir}/sblim-cmpi-dhcp/provider-register.sh -d -t sfcb \
#        -n "root/PG_InterOp" -r %{DHCP_INTEROP_REGISTRATIONS} -m %{DHCP_INTEROP_SCHEMAS} > /dev/null 2>&1 || :;


%post
function register()
{       
  # The follwoing script will handle the registration for various CIMOMs.
  %{_datadir}/%{name}/provider-register.sh \
        $1 \
        -m %{SCHEMA} \
        -r %{REGISTRATION} > /dev/null 2>&1 || :;
  %{_datadir}/%{name}/provider-register.sh \
        $1 \
        -m %{INTEROP_SCHEMA} \
        -r %{INTEROP_REGISTRATION} > /dev/null 2>&1 || :;
  # don't let registration failure when server not running fail install!
}       
        
/sbin/ldconfig
if [ $1 -ge 1 ]
then    
        registered=no
        if [ -e /usr/sbin/cimserver ]; then
          register "-t pegasus";
          registered=yes
        fi
        
        if [ -e /usr/sbin/sfcbd ]; then
          register "-t sfcb";
          registered=yes
        fi
        
        if [ "$registered" != yes ]; then
          register
        fi
fi
#%{_datadir}/sblim-cmpi-dhcp/provider-register.sh -t sfcb \
#         -v -n "root/PG_InterOp" -r %{DHCP_INTEROP_REGISTRATIONS} -m %{DHCP_INTEROP_SCHEMAS} > /dev/null 2>&1 || :;


%preun
function unregister()
{        
  %{_datadir}/%{name}/provider-register.sh -d \
        $1 \
        -m %{SCHEMA} \
        -r %{REGISTRATION} > /dev/null 2>&1 || :;
  %{_datadir}/%{name}/provider-register.sh -d \
        $1 \
        -m %{INTEROP_SCHEMA} \
        -r %{INTEROP_REGISTRATION} > /dev/null 2>&1 || :;
  # don't let registration failure when server not running fail erase!
}        
         
if [ $1 -eq 0 ]
then     
        unregistered=no
        if [ -e /usr/sbin/cimserver ]; then
          unregister "-t pegasus";
          unregistered=yes
        fi
         
        if [ -e /usr/sbin/sfcbd ]; then
          unregister "-t sfcb";
          unregistered=yes
        fi
         
        if [ "$unregistered" != yes ]; then
          unregister
        fi
fi
#  %{_datadir}/sblim-cmpi-dhcp/provider-register.sh -d -t sfcb \
#        -n "root/PG_InterOp" -r %{DHCP_INTEROP_REGISTRATIONS} -m %{DHCP_INTEROP_SCHEMAS} > /dev/null 2>&1 || :;


%postun -p /sbin/ldconfig


%changelog
* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon May 21 2012 Vitezslav Crhonek <vcrhonek@redhat.com> - 1.0-6
- Fix Linux_DHCPServiceConfiguration registration (patch by Roman Rakus)

* Wed May 16 2012 Vitezslav Crhonek <vcrhonek@redhat.com> - 1.0-5
- Fix path to dhcpd config file, Linux_DHCPGlobal registration (patch by Roman Rakus)
- Add registration for various CIMOMs
- Fix build requires and requires

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu May 12 2011 Vitezslav Crhonek <vcrhonek@redhat.com> - 1.0-3
- Add "unused" attribute to unused variables

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec  8 2010 Vitezslav Crhonek <vcrhonek@redhat.com> - 1.0-1
- Update to sblim-cmpi-dhcp-1.0

* Tue Oct  6 2009 Vitezslav Crhonek <vcrhonek@redhat.com> - 0.5.5-1
- Initial support
